GO.projects2.MainPanel = function(config){

	config = config || {};
	config.id=config.id || Ext.id();

	var data = [['project', GO.projects2.lang.project],['job',GO.projects2.lang.task]];
	if(GO.tasks){
		data.push(['task', GO.tasks.lang.task]);
	}
	
	GO.projects2.templateJobTypesStore = new Ext.data.SimpleStore({
		fields : ['value', 'text'],
		data : data
	});

	this.selectProject = new GO.projects2.SelectProject({
			emptyText:GO.projects2.lang.searchProject,
			hideLabel:true,
			anchor:'100%',
			minListWidth:600,
			region: 'northdele',
			store:new GO.data.JsonStore({
				url: GO.url('projects2/project/store'),
				fields:['id', 'path','use_tasks_panel'],
				remoteSort: true
			}),
			listeners:{
				select:function(cmb, record){
					this.project_id=record.id;
					this.tasksPanel.setProjectId(this.project_id,record.data.use_tasks_panel);
					if(this.project_id > 0)
					{
						this.projectPanel.load(this.project_id);
					}
				},
				scope:this
			}
	});

	var subProjectFields = {
		fields: ['id', 'name','reference_no','status_name','user_name','type_name','template_name','responsible_user_name','icon','start_time', 'due_time','customer_name', 'contact'],
		columns: [{
				header: '',
				dataIndex: 'icon',
				xtype: 'iconcolumn'
			},{
				header: 'ID',
				dataIndex: 'id',
				id: 'id',
				width: 50
			},{
				header:GO.lang['strName'],
				dataIndex: 'name',
				id:'name',
				width: 150
			},{
				header:GO.projects2.lang['referenceNo'],
				dataIndex: 'reference_no',
				id:'reference_no',
				width: 150
			},{
				header:GO.projects2.lang['status'],
				dataIndex: 'status_name',
				id:'status_name',
				width: 100
			},{
				header:GO.projects2.lang['startTime'],
				dataIndex: 'start_time',
				id:'start_time',
				width: 80,
				scope: this,
				hidden: true
			},{
				header:GO.projects2.lang['dueAt'],
				dataIndex: 'due_time',
				id:'due_time',
				width: 80,
				renderer: function(value,metaData,record) {
					return '<span class="'+this.projectPanel.templateConfig.getClass(record.data)+'">'+value+'</span>';
				},
				scope: this
			},{
				header: GO.lang['strUser'],
				dataIndex: 'user_name',
				id: 'user_name',
				width: 120,
				sortable:false
			},{
				header: GO.projects2.lang['type'],
				dataIndex: 'type_name',
				id: 'type_name',
				width: 80
			},{
				header: GO.projects2.lang['template'],
				dataIndex: 'template_name',
				id: 'template_name',
				width: 80
			},{
				header: GO.projects2.lang['projectManager'],
				dataIndex: 'responsible_user_name',
				id: 'responsible_user_name',
				width: 120,
				sortable:false
			},{
				header: GO.projects2.lang['customer'],
				dataIndex: 'customer_name',
				id: 'customer_name',
				width: 120,
				sortable:false
			},{
				header: GO.projects2.lang['contact'],
				dataIndex: 'contact',
				id: 'contact',
				width: 120,
				sortable:false
			}]
	}

	if(GO.customfields){
		GO.customfields.addColumns("GO\\Projects2\\Model\\Project", subProjectFields);
	}

	var exportBtn = new GO.base.ExportMenu({className:'GO\\Projects2\\Export\\CurrentGrid'});
	exportBtn.iconCls = null;

var subProjectsStore = new GO.data.JsonStore({
			url: GO.url('projects2/project/store'),
			baseParams: {
				parent_project_id: 0
			},
			root: 'results',
			totalProperty: 'total',
			id: 'id',
			fields: subProjectFields.fields,
			remoteSort:true
		});

	this.subProjectsGrid = new GO.grid.GridPanel({
		tbar: [exportBtn,
			this.searchField = new GO.form.SearchField({
				store: subProjectsStore,
				width:120,
				emptyText: GO.lang.strSearch
			}),
			this.showMineOnlyField = new Ext.form.Checkbox({
			boxLabel: GO.projects2.lang.showMineOnly,
			labelSeparator: '',
			name: 'show_mine_only',
			allowBlank: true,
			ctCls:'apr-show-mine-only-cb'
		})],
		border: false,
		region: 'south',
		height:300,
		hidden:true,
		layout:'fit',
		enableDragDrop: true,
		ddGroup: 'ProjectsDD',
		id:'pr2-sub-projects',
		split: true,
		store: subProjectsStore,
		autoScroll:true,
		paging : true,
		sm: new Ext.grid.RowSelectionModel(),
		cm: new Ext.grid.ColumnModel({
			defaultSortable:true,
			columns:subProjectFields.columns

		}),
		view:new Ext.grid.GridView({
			forceFit:false,
			autoFill:false
			}),
		scope: this
	});
	
	exportBtn.setColumnModel(this.subProjectsGrid.getColumnModel());
	
	this.subProjectsGrid.on('rowdblclick',function(grid,rowIndex,event){
		var record = grid.store.getAt(rowIndex);
		this._switchProject(record.data.id);
	},this);


	this.treePanel = new GO.projects2.ProjectsTree({
		width:250,
		split:true,
		autoScroll:true,
		region:'center',
		border:true,
		grid: this.subProjectsGrid
	});
	
	this.subProjectsGrid.store.on('load',function(store,records,options){
		this.showMineOnlyField.setValue(!GO.util.empty(store.reader.jsonData.showMineOnly));
	},this);
	
	this.showMineOnlyField.on('check', function(checkBox,checked){
		this.subProjectsGrid.store.baseParams.showMineOnly = checked;
		this.subProjectsGrid.store.load();
		delete this.subProjectsGrid.store.baseParams.showMineOnly;
	},this);

	this.treePanel.on('click',function(){
		this.project_id=this.treePanel.project_id;
		this._switchProject(this.project_id)
	}, this);
	
	this.statusesFilterGrid = new GO.projects2.StatusesFilterGrid({
		region:'south',
		id:'pr2-statuses',
		width:180,
		height:250
	});

	this.selectManagerField = new GO.form.SelectUser({
			hiddenName:'manager_id',
			emptyText: GO.projects2.lang.filterManager,
			startBlank:true,
			hideLabel: true,
			minListWidth: 300,
			allowBlank:true,
			displayField: 'name',
			valueField:'id',
			anchor: '100%',
			store: new GO.data.JsonStore({
				url: GO.url('projects2/employee/users'),
				root: 'results',
				totalProperty: 'total',
				id: 'id',
				fields:['id','name'],
				remoteSort: true
			}),
			listeners: {
				select: function (cmb, record) {
					// Set the selected manager parameter for the treeloader
					this.treePanel.treeLoader.baseParams.manager_id = record.id;
					this.selectProject.store.baseParams.manager_id = record.id;
					this.selectProject.clearValue();
					this.selectProject.store.reload();
					this.treePanel.rootNode.reload();
				},
				clear: function (){
					// Clear the manager parameter for the treeloader
					this.treePanel.treeLoader.baseParams.manager_id = null;
					this.selectProject.store.baseParams.manager_id = null;
					this.selectProject.store.reload();
					this.treePanel.rootNode.reload();
				},
				scope: this
			}
		});


	var items = [];

	items.push({
		region:'north',
		height:60,
		cls:'go-form-panel',
		layout:'form',
		items:[
			this.selectManagerField,
			this.selectProject			
		]

	},this.treePanel

	,this.statusesFilterGrid

	);

	this.westPanel = new Ext.Panel({
		id:config.id+'-west',
		region:'west',
		layout:'border',
		border:false,
		split:true,
		width:250,
		items:items,
		collapsible:true,
		collapseMode:'mini',
		header:false
	});


	this.projectPanel = new GO.projects2.ProjectPanel({
		region: 'center',
		id:'pr2-project-panel'
	});
	this.projectPanel.on("fullReload", function (panel) {
		this.refresh();
		
		this._switchProject(panel.data.parent_project_id);
		
	}, this);

	this.projectPanel.on('load', function(tp, project_id){

		this.project_id=project_id;
		this.tasksPanel.setProjectId(project_id,tp.data.use_tasks_panel==1);

		var node = this.getTreePanel().getNodeById(project_id);
		
		if(node && node.rendered){
			this.getTreePanel().getSelectionModel().select(node);
			node.expand();
		}

		if(project_id>0 && !this.projectPanel.data.write_permission){
			this.addButton.setDisabled(true);
		} else {
			this.addButton.setDisabled(false);
		}

		if(project_id>0 && this.projectPanel.data.has_children){
			this.subProjectsGrid.store.baseParams['parent_project_id'] = project_id;
			this.subProjectsGrid.store.load();
			this.subProjectsGrid.setVisible(true);
		} else {
			this.subProjectsGrid.store.baseParams['parent_project_id'] = 0;
			this.subProjectsGrid.store.removeAll();
			this.subProjectsGrid.setVisible(false);
		}

		this.centerPanel.doLayout();

	}, this);
	
	this.projectPanel.on('reset', function(){
		this.subProjectsGrid.store.baseParams['parent_project_id'] = 0;
		this.subProjectsGrid.store.load();
		this.subProjectsGrid.setVisible(true);
		
		this.centerPanel.doLayout();
	}, this);

	this.centerPanel = new Ext.Panel({
		region: 'center',
		layout:'border',
		split:true,
		id:this.id+'_east',
		items: [
			this.projectPanel,
			this.subProjectsGrid
		]
	})

	this.tasksPanel = new GO.projects2.TasksGrid({
		region:'east',
		width: 500,
		id:'pm-tasks',
		collapsible:true
	});

	config.items=[
		this.westPanel,
		this.tasksPanel,
		this.centerPanel
	];

	this.statusesFilterGrid.on('change', function(grid, statuses, records)
	{
		this.onChangeStatusesFilterGrid(grid, statuses, records);
	}, this);

	var items = [
	{
		xtype:'htmlcomponent',
		html:GO.projects2.lang.projects,
		cls:'go-module-title-tbar'
	}];

	this.addButton = new Ext.Button({
		iconCls: 'btn-add',
		text: GO.projects2.lang['addProject'],
		cls: 'x-btn-text-icon',
		handler: function(){
			if(GO.projects2.max_projects>0 && this.store.totalLength>=GO.projects2.max_projects){
				Ext.Msg.alert(GO.lang.strError, GO.projects2.lang.maxProjectsReached);
			} else {
				GO.projects2.showProjectDialog({
					parent_project_id: this.project_id
				});
			}
		},
		scope: this
	});
	items.push(this.addButton);

	if(GO.settings.modules.projects2.permission_level==GO.permissionLevels.manage)
	{
		
		items.push({
			iconCls:'btn-delete',
			text:GO.lang.cmdDelete,
			handler:function(){
				if(this.project_id && this.project_id != 0) {
						if(confirm(GO.lang.areYouSureDeleteItem.replace('{item}','#'+this.project_id))){
						GO.request({
							url:'projects2/project/delete',
							params:{id:this.project_id},
							scope:this,
							success:function(){
								if(this.treePanel.selModel && this.treePanel.selModel.selNode){
									if(this.treePanel.selModel.selNode.id == this.project_id) {
										this.treePanel.selModel.selNode = this.treePanel.selModel.selNode.parentNode;
									}
									this.treePanel.selModel.selNode.select();
									this.treePanel.selModel.selNode.reload();
									
									this.treePanel.fireEvent('click', this.treePanel.selModel.selNode);
								}
							}
						});
					}
				}
			},
			scope:this
		});

		items.push({
			iconCls:'btn-settings',
			text:GO.lang.administration,
			handler:function(){
				if(!this.settingsDialog)
				{
					this.settingsDialog = new GO.projects2.SettingsDialog();
				}
				this.settingsDialog.show();
			},
			scope:this
		});

	}
	items.push({
		iconCls:'btn-actions',
		text:GO.projects2.lang.report,
		hidden: GO.settings.modules.projects2.permission_level<GO.projects2.permissionLevelFinance,
		handler:function(){
			if(!this.reportDialog)
			{
				this.reportDialog = new GO.projects2.ReportDialog();
			}
			this.reportDialog.show();
		},
		scope:this
	});

	items.push({
		iconCls:'btn-refresh',
		text:GO.lang.cmdRefresh,
		handler:function(){
			this.refresh();
		},
		scope:this
	});

	if(GO.settings.modules.projects2.permission_level==GO.permissionLevels.manage)
	{
		items.push({
			iconCls:'btn-add',
			text:GO.lang.cmdImport,
			handler:function(){
				if(!this.importDialog)
				{
					this.importDialog = new GO.projects2.CsvImportDialog();
				}
				this.importDialog.show();
			},
			scope:this
		});
	}

	this.invoiceButton = new Ext.Button({
		iconCls: 'btn-add',
		text: GO.projects2.lang['financial'],
		handler: function() {
			if(!this.invoiceDialog)
				this.invoiceDialog = GO.projects2.invoiceDialog = new GO.projects2.InvoiceDialog();
			this.invoiceDialog.show();
		},
		scope:this
	});
	items.push(this.invoiceButton);
	config.tbar = new Ext.Toolbar({
		cls:'go-head-tb',
		items:items
	});

	config.border=false;
	config.layout='border';
	GO.projects2.MainPanel.superclass.constructor.call(this, config);

	this.tasksPanel.on('saved', function(projectId){
		if (this._saveTaskPanelBeforeLeaving) {
			this.selectProject.reset();
			if(projectId > 0)
			{
				this.projectPanel.load(projectId);
			}else
			{
				this.projectPanel.reset();
			}
			this._saveTaskPanelBeforeLeaving = false;
		}
	}, this);

	this.on('show', function() {
		this.statusesFilterGrid.store.load();
	}, this);
};

Ext.extend(GO.projects2.MainPanel, Ext.Panel, {

	project_id : 0,

	_saveTaskPanelBeforeLeaving : false,


	refresh : function(){
		this.getTreePanel().rootNode.reload();
	},

	onChangeStatusesFilterGrid : function(grid, statuses, records){
		this.getTreePanel().treeLoader.baseParams.pr2_statuses = Ext.encode(statuses);
		var node = this.getTreePanel().getNodeById(this.project_id) || this.getTreePanel().getRootNode();
		this.getTreePanel().getRootNode().reload();
		delete this.subProjectsGrid.store.baseParams.statuses;
		
		this.subProjectsGrid.store.baseParams['parent_project_id'] = this.project_id;
		this.subProjectsGrid.store.load();
		this.subProjectsGrid.setVisible(true);
		
		this.centerPanel.doLayout();
	},

	getTreePanel : function(){
		return this.treePanel;
	},

	afterRender : function(){

		GO.projects2.MainPanel.superclass.afterRender.call(this);
		GO.dialogListeners.add('project',{
			scope:this,
			save:function(e, project_id, parent_project_id){
				this.getTreePanel().reloadActiveNode();
			}
		});
		
		
		this.subProjectsGrid.store.baseParams['parent_project_id'] = 0;
		this.subProjectsGrid.store.load();
		this.subProjectsGrid.setVisible(true);
		
	},

	_switchProject : function(projectId) {

		if (!this.tasksPanel.isDirty()) {
			this.selectProject.reset();

			if(projectId > 0){
				this.projectPanel.load(projectId);
			} else {
				this.projectPanel.reset();
					
				// Disable the "Add project" button when the root node is clicked and the user doesn't have manage permissions on the project2 module.
				if(!GO.settings.modules.projects2.write_permission){
					this.addButton.setDisabled(true);
				} else {
					this.addButton.setDisabled(false);
				}
			}
		} else {
			Ext.Msg.show({
				title: GO.projects2.lang['saveBeforeLeavingTitle'],
				msg: GO.projects2.lang['saveBeforeLeavingMsg'],
				buttons: Ext.Msg.YESNOCANCEL,
				scope: this,
				fn: function(btn) {
					if (btn=='no') {
						this.selectProject.reset();

						if(projectId > 0)
						{
							this.projectPanel.load(projectId);
						}else
						{
							this.projectPanel.reset();
						}
					} else if (btn=='yes') {
						this._saveTaskPanelBeforeLeaving = true;
						this.tasksPanel.save(projectId);
					}
				}
			});
		}
	}
});

GO.projects2.showProjectDialog = function(config){
	if(!GO.projects2.projectDialog)
		GO.projects2.projectDialog = new GO.projects2.ProjectDialog();
	GO.projects2.projectDialog.show(config);
};

/**
 * Open the projects2 tab and select the given project
 * 
 * @param int id The project id
 */
GO.projects2.openProjectTab = function(id){
	GO.mainLayout.openModule('projects2');
	
	var pr2Panel = GO.mainLayout.getModulePanel('projects2');
	pr2Panel._switchProject(id);
};


/*
 * This will add the module to the main tabpanel filled with all the modules
 */

GO.moduleManager.addModule('projects2', GO.projects2.MainPanel, {
	title : GO.projects2.lang.projects,
	iconCls : 'go-tab-icon-projects'
});

GO.linkPreviewPanels["GO\\Projects2\\Model\\Project"]=function(config){
	config = config || {};
	return new GO.projects2.ProjectPanel(config);
}

/*
 * If your module has a linkable item, you should add a link handler like this.
 * The index (no. 1 in this case) should be a unique identifier of your item.
 * See classes/base/links.class.inc for an overview.
 *
 * Basically this function opens a project window when a user clicks on it from a
 * panel with links.
 */
GO.linkHandlers["GO\\Projects2\\Model\\Project"]=function(id){
	if(!GO.projects2.linkWindow){
		var projectPanel = new GO.projects2.ProjectPanel();
		GO.projects2.linkWindow = new GO.LinkViewWindow({
			title: GO.projects2.lang.project,
			projectPanel: projectPanel,
			items: projectPanel,
			width:600,
			closeAction:"hide"
		});
	}
	GO.projects2.linkWindow.show();
	GO.projects2.linkWindow.projectPanel.load(id);
	return GO.projects2.linkWindow;
}

GO.newMenuItems.push({
    text: GO.projects2.lang.project,
    iconCls: 'go-model-icon-GO_Projects2_Model_Project',
    handler:function(item, e){
			GO.projects2.showProjectDialog({
				link_config: item.parentMenu.link_config
			});
    }
});

GO.projects2.permissionLevelFinance = 45;
